#!/usr/bin/perl -w -I/usr/sausalito/perl
#
# $Id: ia5string_check.pl,v 1.1.2.1 2002/03/28 09:16:31 pbaltz Exp $
# Copyright 2002 Sun Microsystems, Inc.  All rights reserved.
#
# check ssl fields to make sure all data is ascii
#

use CCE;

my $cce = new CCE('Namespace' => 'SSL', 'Domain' => 'base-ssl');
$cce->connectfd();

my $ssl_info = $cce->event_object();

for my $property ('city', 'state', 'orgName', 'orgUnit', 'email') {
	if ($ssl_info->{$property} eq '') {
		next;
	}

	for (my $i = 0; $i < length($ssl_info->{$property}); $i++) {
		my $byte = substr($ssl_info->{$property}, $i, 1);

		if ((ord($byte) & 127) != ord($byte)) {
			# non-ascii fail
			$cce->baddata($cce->event_oid(), $property,
				'nonAsciiCharacter',
				{ 'property' => "[[base-ssl.$property]]" });
			$cce->bye('FAIL');
			exit(1);
		}
	}
}

$cce->bye('SUCCESS');
exit(0);
