#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: vsite_change_ip.pl,v 1.1.2.1 2002/01/15 21:01:14 pbaltz Exp $
# Copyright 2002 Sun Microsystems, Inc.  All rights reserved.
#
# make sure if a vsite's ip address is changed that two sites with the
# same IP address don't end up having SSL enabled
#

use CCE;

my $cce = new CCE('Domain' => 'base-ssl', 'Namespace' => 'SSL');
$cce->connectfd();

my $ssl_info = $cce->event_object();

# if SSL is not enabled, just exit with success
if (!$ssl_info->{enabled}) {
	$cce->bye('SUCCESS');
	exit(0);
}

# need to get the vsite for the IP address
my ($ok, $vsite) = $cce->get($cce->event_oid());
if (!$ok) {
	$cce->bye('FAIL', 'cantGetVsite');
	exit(1);
}

my @other_sites = $cce->find('Vsite',
			     {
				'ipaddr' => $vsite->{ipaddr},
				'SSL.enabled' => 1
			     });

if (scalar(@other_sites) > 1) {
	$cce->bye('FAIL', 'sslMigrationConflict',
		  { 'ipaddr' => $vsite->{ipaddr} });
	exit(1);
}

# otherwise, everything is okay
$cce->bye('SUCCESS');
exit(0);
