#!/usr/bin/perl -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/ssl
# $Id: vsite_ssl.pl,v 1.12 2001/11/04 22:11:54 pbaltz Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.
# update siteAdminCaps property when enabling/disabling ssl

my $DEBUG = 0;

use File::Copy;
use CCE;
use Base::Vsite qw(vsite_update_site_admin_caps);

my $cce = new CCE('Domain' => 'base-ssl');
$cce->connectfd();

# get vsite and ssl information for the vsite
my $vsite = $cce->event_object();
my $oid = $cce->event_oid();
my ($ok, $ssl_info) = $cce->get($oid, 'SSL');
$DEBUG && print STDERR Dumper($vsite, $ssl_info);

# make sure two sites with the same IP address don't both get SSL enabled
my @other_sites = $cce->findx('Vsite', 
                        { 'ipaddr' => $vsite->{ipaddr}, 'SSL.enabled' => 1 });

if ($ssl_info->{enabled} && scalar(@other_sites) > 1)
{
    my $oid_to_get = $other_sites[0] != $oid ? $other_sites[0] : $other_sites[1];
    ($ok, my $other_site) = $cce->get($oid_to_get);
                                
    $cce->bye('FAIL', 'sslAlreadyUsedByIP', 
                { 
                    'fqdn' => $other_site->{fqdn}, 
                    'ipaddr' => $other_site->{ipaddr} 
                });
    exit(1);
}

# update siteAdminCaps in Vsite
if (!$cce->event_is_destroy())
{
    vsite_update_site_admin_caps($cce, $vsite, 'siteSSL', $ssl_info->{enabled});
}

$cce->bye('SUCCESS');
exit(0);
